unit Fakultaetsberechnung;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, LangZahlRechnen;

type
  TFakultaet = class(TForm)
    LabelN: TLabel;
    Zahl: TEdit;
    Start: TButton;
    LabelE: TLabel;
    Ausgabe: TListBox;
    Anzahl: TLabeledEdit;
    LabelZeit: TLabel;
    LabelSek: TLabel;
    procedure StartClick(Sender: TObject);
    function TimeSekunden:Extended;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Fakultaet: TFakultaet;

implementation

{$R *.DFM}
{$R+,Q+}

 function TFakultaet.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+1.0*S+MS/1000
  end;

 procedure TFakultaet.StartClick(Sender: TObject);
  const Null='00000000000000000000';
  var I,N,Ziffern:Integer;
      Zeit:Extended;
      Fakultaet,Faktor:TFeld;
  begin
   N:=StrToInt(Zahl.Text);
   Ausgabe.Clear;
   Screen.Cursor:=crHourGlass;
   Zeit:=TimeSekunden;
   LangInt(Fakultaet,1);
   for I:=2 to N do
    Begin
     LangInt(Faktor,I);
     LangMul(Fakultaet,Fakultaet,Faktor);
    End;
   Zeit:=TimeSekunden-Zeit;
   Screen.Cursor:=crDefault;
   LangAusgabe(Ausgabe,Fakultaet);
   LabelE.Caption:=IntToStr(N)+'!';
   Ziffern:=9*(Length(Fakultaet)-2)+Trunc(LN(Fakultaet[Length(Fakultaet)-1])/LN(10))+1;
   Anzahl.Text:=Format('%0d',[Ziffern]);
   LabelSek.Caption:=Format('%0.2f',[Zeit])+' sek.';
  end;

end.
